class container;
  // 2-dimensional dynamic array of queues of trans_obj handles
  trans_obj mda_q [][][$];
  int rows, cols; // default values are 0


  function void set_queues(int row, int col);
    rows = row;
    cols = col;
    mda_q = new[row];   // ILLEGAL: mda_q = new[row][col];
    // foreach loop used to initialize column sizes
    foreach(mda_q[row]) mda_q[row] = new[col];

  endfunction

  function void rand_init(int row, int col, int q_depth);
    trans_obj tr = new();
    int       q_rand_depth;

    for (int i=0; i<(row-1); i++) begin
      for (int j=0; j<(col-1); j++) begin
	// randomize q-depth for each queue
        q_rand_depth = $urandom_range(q_depth-1); 
        for (int k=0; k<(q_rand_depth-1); k++) begin
	  void'(tr.randomize());
	  add(tr, i, j); // add to queue at [i][j]
        end
      end
    end
  endfunction

  //-----------------------------------------------
  // returns total number of trans_obj handles from 
  // 2-dimensional dynamic array of queued handles
  //-----------------------------------------------
  function int get_num();
    foreach(mda_q[i,j]) get_num += mda_q[i][j].size();
  endfunction

  function void add (trans_obj obj, int row, int col);
    // checks for legality not shown
    mda_q[row][col].push_back(obj);

  endfunction

  // If number of trans_obj handles is not 0, remove
  // and return the first queued trans_obj handle
  function trans_obj get_first(int row, int col);
    if (mda_q[row][col].size()) begin
      get_first = mda_q[row][col].pop_front();

    end
  endfunction
endclass

// Figure 1:  Inefficient get_num function (code in bold)
