//----------------------------------------------------------------------
// This File: top.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------
`include "CYCLE.sv"
`include "CNT_file"
`include "uvm_includes.sv"
module top;
  `ifdef TXN15

  `include "txn15.sv"
  txn15 t = new();

  `else

  `include "txn16.sv"
  txn16 t = new();

  `endif

  logic       clk;

  // Instantiate clkgen
  clkgen         ck  (clk);

  initial begin
    forever begin
      void'(t.randomize());
      t.show_payload();
      repeat(`CNT/5) @(posedge clk) void'(t.randomize());
    end
  end

  initial begin
    repeat(`CNT) @(posedge clk);
    $finish;
  end
endmodule
