//----------------------------------------------------------------------
// This File: top.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------
`include "CYCLE.sv"
`include "CNT_file"
module top;
  logic [7:0] b, c, d;
  logic       a;
  logic       clk;

  `ifdef LOCAL

  `include "assert_lv.sv"

  `else

  `include "assert_past.sv"

  `endif

  // Instantiate clkgen
  clkgen         ck  (clk);

  initial begin
    initialize();
    forever begin
      a++; // toggle a
      {b, c, d} = $urandom;
      repeat(2) @(posedge clk);
      d = b;
      a++; // toggle a
      @(posedge clk);
    end
  end

  initial begin
    repeat(`CNT) @(posedge clk);
    $finish;
  end
  
  task initialize();
    {a, b, c, d} <= '0;
    @(posedge clk);
  endtask
endmodule
