module top;
  bit [31:0] addr1, addr2;
  bit [15:0] data;
  bit        collect_cov;
  bit        valid;   // triggering event

  logic clk;
  `include "CNT_file"

  covergroup cg1;
    adr1: coverpoint addr2 {
            bins a[4] = {[0:$]}; 
          }
  endgroup

  covergroup cg2;
    adr2: coverpoint addr2 {
            bins a[4] = {[0:$]}; 
          }
  endgroup

  covergroup cg3;
    dat1: coverpoint data {
            bins d[4] = {[0:$]}; 
          }
  endgroup

  clkgen i1 (.clk(clk));

  cg1 c1 = new();
  cg2 c2 = new();
  cg3 c3 = new();

  initial begin
    forever @(posedge clk) begin
      addr1 = $urandom;
      addr2 = $urandom;
      data  = $urandom;
      {collect_cov, valid}  = $urandom_range(0,3);;
    end
  end

  initial begin
    repeat(`CNT) @(posedge clk);
    $finish;
  end

  `ifdef MERGED

  // Sampling merged to a single event 
  always @(posedge valid iff collect_cov) begin
    c1.sample();
    c2.sample();
    c3.sample();
  end

  `else

  always @(posedge valid iff collect_cov)
    c1.sample();

  always @(posedge valid iff collect_cov)
    c2.sample();

  always @(posedge valid iff collect_cov)
    c3.sample();

  `endif
endmodule
