`include "CYCLE.sv"
`include "CNT_file"

module top;
  logic [7:0] a, b, y;
  logic       clk;
  int         cnt;
  int         max = `CNT-5;

  clkgen      cg   (.clk(clk));

  A6 i1 (.y(y), .a(a), .b(b));

  always @(posedge clk) begin
    a = $urandom_range(255);
    b = $urandom_range(255);
    //--------------------------------------------------
    // Sanity check to make sure the test is running:
    // Display first 5 and last 5 a, b, y and cnt values
    //--------------------------------------------------
    if ((cnt <5) || (cnt>max)) 
      $display("y=%2h  a=%2h  b=%2h  cnt=%d", y, a, b, cnt);
    cnt++;
  end

  initial begin
    repeat(`CNT) @(posedge clk);
    $finish;
  end
endmodule

// Port-collapsing top-module
