module BEN11B (
  output logic [31:0] counter,
  input  logic        req, ack,
  input  logic        clk, rst_n);

  enum logic [2:0] {
                    IDLE,
                    S1,
                    S2,
                    S3,
                    S4,
                    XXX} state, next;

  always_ff @(posedge clk, negedge rst_n)
    if (!rst_n) state <= IDLE;
    else        state <= next;

  always_comb begin
    next = XXX;
    case(state)
      IDLE: if( req) next = S1;
            else     next = IDLE;
      S1:   if( ack) next = S2;
            else     next = S1;
      S2:   if(!req) next = S4;
            else     next = S3;
      S3:   if(!req) next = S4;
            else     next = S3;
      S4:   if(!ack) next = IDLE;
            else     next = S4;
      default:       next = XXX;
    endcase
  end
  
  always_ff @(posedge clk, negedge rst_n)
    if (!rst_n) counter <= '0;
    else begin
      case (next)
        IDLE, S1, S3, S4: ; // No counter change
        S2     : counter <= counter + 1;
        default: counter <= XXX;
      endcase
    end
endmodule
