`include "CNT_file"
module top;
  logic        ack, req;
  logic        clk, rst_n;
  logic [31:0] counter [0:1];

  logic  [1:0] val;

  clkgen c1 (clk);

  `ifdef FSM1
  BEN11B fsm1 (.counter(counter[0]), .ack(ack), .req(req), .clk(clk), .rst_n(rst_n));
  `endif

  `ifdef FSM2
  BEN11A fsm2 (.counter(counter[1]), .ack(ack), .req(req), .clk(clk), .rst_n(rst_n));
  `endif

  initial begin
    initialize();
    fork
      run_noreset(`CNT);
      begin
        reset(37);
        reset(142);
        reset(126);
        reset(31);
        reset(131);
        reset(231);
        reset(182);
      end
    join
    FINISH;
  end

  task reset(int cnt=1);
    @(posedge clk) `Tdrive;
    rst_n = '1;
    $display("Running reset %0d", cnt);
    repeat (cnt) @(posedge clk);
    `Tdrive;
    rst_n = '0;
    @(posedge clk) `Tdrive;
    rst_n = '1;
  endtask

  task run_noreset(int cnt=1);
    $display("Running run_noreset %0d", cnt);
    repeat (cnt) begin
      repeat(2) @(posedge clk) `Tdrive;
      {ack, req} = 2'b00;
      repeat(2) @(posedge clk) `Tdrive;
      {ack, req} = 2'b01;
      repeat(2) @(posedge clk) `Tdrive;
      {ack, req} = 2'b11;
      repeat(2) @(posedge clk) `Tdrive;
      {ack, req} = 2'b10;
    end
  endtask

  task initialize();
    rst_n <= '0;
    req   <= '0;
    ack   <= '0;
  endtask

  task FINISH(int cnt=1);
    repeat (cnt) @(posedge clk);
    `Tdrive $finish;
  endtask
endmodule
