//----------------------------------------------------------------------
// This File: mem_print_test.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------
`include "CNT_file"
class mem_print_test;
  int mem [47:0];

  virtual clk_if vif;

  function new(virtual clk_if nif);
    vif = nif;
  endfunction

  task run();
    set_data(32'h0000_0000);
    repeat (`CNT/10) get_data();
    set_data(32'h1111_1111);
    repeat (`CNT/10) get_data();
    set_data(32'h2222_2222);
    repeat (`CNT/10) get_data();
    set_data(32'h3333_3333);
    repeat (`CNT/10) get_data();
    set_data(32'h4444_4444);
    repeat (`CNT/10) get_data();
    set_data(32'h5555_5555);
    repeat (`CNT/10) get_data();
    set_data(32'h6666_6666);
    repeat (`CNT/10) get_data();
    set_data(32'h7777_7777);
    repeat (`CNT/10) get_data();
    set_data(32'h8888_8888);
    repeat (`CNT/10) get_data();
    set_data(32'h9999_9999);
    repeat (`CNT/10) get_data();
  endtask

  function void set_data(int data, bit random='0);
    if (random) for (int i=0; i<48; i++) mem[i] = $urandom;
    else                                 mem    = '{default:data};
  endfunction

  function void get_data();
    string memlayout;

    `ifdef FAST
    // Only do expensive string processing for UVM_HIGH or higher verbosity
    if(uvm_report_enabled(UVM_HIGH, UVM_INFO, "MEMDATA")) begin
    `endif
      // Format the memory layout into a string
      memlayout = "  {\n";
      foreach(mem[i]) 
          memlayout = $sformatf("%s    mem[%0d]:%8h", memlayout, i, mem[i]);
      memlayout = {memlayout, "  }\n"};
    `ifdef FAST
    end
    `endif
    `uvm_info("MEMDATA", memlayout, UVM_HIGH)
   endfunction
endclass
