//----------------------------------------------------------------------
// This File: top.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------
`include "CYCLE.sv"
`include "uvm_macros.svh"
module top;
  import uvm_pkg::*; // import uvm base  classes
  import  tb_pkg::*; // import testbench classes

  logic       clk;

  // Instantiate clkgen
  clkgen         ck  (clk);

  // instantiate clk interface
  clk_if         cif (clk);

  mem_print_test m1;

  initial begin
    m1 = new(cif);
    `uvm_info("TOP","Starting to run m1.run()", UVM_MEDIUM)
    m1.run();
    `uvm_info("TOP","Done running m1.run()", UVM_MEDIUM)
    $finish;
  end
endmodule
