//----------------------------------------------------------------------
// This File: dut.sv
//            (2-register dut)
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

module dut (
  output logic [15:0] data1, data2,
  input        [15:0] din1,  din2,
  input               clk, rst_n);

  always_ff @(posedge clk, negedge rst_n)
    if (!rst_n) begin
      data1 <= '0;
      data2 <= '0;
    end
    else begin
      data1 <= din1;
      data2 <= din2;
    end
endmodule
