//----------------------------------------------------------------------
// This File: dut_if.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// Drive the stimulus 20% of the CYCLE time after posedge clk
//----------------------------------------------------------------------
`include "CYCLE.sv"
`define Tdrive #(0.2*`CYCLE)

interface dut_if (input clk);
  logic [15:0] data1, data2;
  logic [15:0] din1,  din2;
  logic        rst_n;

  clocking cb1 @(posedge clk);
    default input #1step output `Tdrive;
    input  data1, data2;
    output din1,  din2;
    output rst_n;
  endclocking
endinterface
