//----------------------------------------------------------------------
// This File: env.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

class env extends uvm_env;
  `uvm_component_utils(env)

  tb_agent      agnt;

  `ifndef FAST
  tb_cover      cov;
  `endif

  function new (string name, uvm_component parent);
    super.new(name, parent);
  endfunction

  function void build_phase(uvm_phase phase);
    super.build_phase(phase);
    agnt =      tb_agent::type_id::create("agnt", this);
  `ifndef FAST
    cov  =      tb_cover::type_id::create("cov",  this);
  `endif
  endfunction

  `ifndef FAST
  function void connect_phase(uvm_phase phase);
    super.connect_phase(phase);
    agnt.ap.connect(cov.analysis_export);
  endfunction
  `endif
endclass

