//----------------------------------------------------------------------
// This File: figure14.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

class mycollector extends uvm_component;
  `uvm_componenet(mycollector)

  virtual dut_if;

  function new(straing name, uvm_component parent);
    super.new(name, parent);
  endfunction

  analysis_port #(trans1) data_port = new("data_port", this);

  `ifdef FAST

  // Figure 14b
  task run_phase(uvm_phase phase);
    if(data_port.size()) forever collect();
  endtask

  `else

  // Figure 14a
  task run_phase(uvm_phase phase);
    forever collect();
  endtask

  `endif

  task collect();
    trans1 tr = trans1::type_id::create("tr");
    get_txn_from_interface(tr);
    data_port.write(tr);
  endtask

  task get_txn_from_interface(mydata tr);
    tr.data1 = vif.data1;
    tr.data2 = vif.data2;
    @vif.cb1);
  endtask

endclass

// Figure 14a:  Unconditionally broadcast UVM analysis port transactions
// Figure 14b:  Conditionally broadcast UVM analysis port transactions

class mydata extends uvm_sequence_item;
  `uvm_object(mydata)

  rand int data1, data2;

  function new(string name="mydata");
    super.new(name);
  endfunction
endclass
