//----------------------------------------------------------------------
// This File: tb_driver.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

class tb_driver extends uvm_driver #(trans1);
  `uvm_component_utils(tb_driver)

  virtual dut_if vif;

  function new (string name, uvm_component parent);
    super.new(name, parent);
  endfunction

  task run_phase(uvm_phase phase);
    trans1 tr;
    initialize();
    forever begin
      `uvm_info("DEBUG: Driver Run",  "... getting next item ...", UVM_DEBUG)
      seq_item_port.get_next_item(tr);
      drive_item(tr);
      seq_item_port.item_done();
      `uvm_info("DEBUG: Driver Run",     "... next item done ...", UVM_DEBUG)
    end
  endtask

  task initialize (); // @0 - Does not use clocking block
    `uvm_info("INIT", "Initialize (time @0)", UVM_HIGH)
     vif.rst_n <= '0;
     vif.din1  <= '1;
     vif.din2  <= '1;
  endtask

  task drive_item (trans1 tr);
    @vif.cb1;                   //@(posedge vif.clk); 
    `uvm_info("drive_item", tr.convert2string(), UVM_DEBUG)
     vif.cb1.rst_n <= '1;
     vif.cb1.din1  <= tr.din1;
     vif.cb1.din2  <= tr.din2;
  endtask
endclass
