//----------------------------------------------------------------------
// This File: tb_monitor.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

class tb_monitor extends uvm_monitor;
  `uvm_component_utils(tb_monitor)

  virtual dut_if vif;

  function new(string name, uvm_component parent);
    super.new(name, parent);
  endfunction

  uvm_analysis_port #(trans1) ap = new("ap", this);

  `ifdef FAST

  // Figure 14b: Conditionally broadcast UVM analysis port transactions
  task run_phase(uvm_phase phase);
    if(ap.size()) forever collect();
  endtask

  `else

  // Figure 14a: Unconditionally broadcast UVM analysis port transactions
  task run_phase(uvm_phase phase);
    forever collect();
  endtask

  `endif

  task collect();
    trans1 tr = trans1::type_id::create("tr");
    get_txn_from_interface(tr);
    ap.write(tr);
  endtask

  task get_txn_from_interface(trans1 tr);
    tr.data1 = vif.data1;
    tr.data2 = vif.data2;
    @vif.cb1;
  endtask

endclass
