//----------------------------------------------------------------------
// This File: top.sv
//
// DVCon 2019 Paper Example
//
// Sunburst Design (Provo, UT):
//            cliffc@sunburst-design.com
//            www.sunburst-design.com
//----------------------------------------------------------------------

`include "CYCLE.sv"
`include "uvm_macros.svh"
module top;
  import uvm_pkg::*; // import uvm base  classes
  import  tb_pkg::*; // import testbench classes

  logic       clk;

  // Instantiate clkgen
  clkgen         ck  (clk);

  // Instantiate DUT
  // DUT must connect to internal interface signals hierarchically
  dut    i1  (.data1(dif.data1), .data2(dif.data2),
              .din1(dif.din1),    .din2(dif.din2), .rst_n(dif.rst_n), .*);

  // instantiate real DUT interface and DUT wrapper
  dut_if dif (clk);

  initial begin
    uvm_config_db#(virtual dut_if)::set(null, "*", "vif", dif);  // UVM-style
    run_test();
  end
endmodule
